//  File:  thermistorFun.cpp
//
//  Read a thermistor with Arduino and return temperature

#include "WProgram.h"
#include "thermistorFun.h"

float thermistorRead(int Tpin) {
  int   Vo;
  float logRt,Rt,T;
  float R = 9870;          //  fixed resistance, measured with multimeter
  //  c1, c2, c3 are calibration coefficients for a particular thermistor
  float c1 =  1.009249522e-03, c2 = 2.378405444e-04, c3 = 2.019202697e-07;
 
  Vo = analogRead(Tpin);
  Rt = R*( 1024.0 / float(Vo) - 1.0 ); 
  logRt = log(Rt);
  T = ( 1.0 / (c1 + c2*logRt + c3*logRt*logRt*logRt ) ) - 273.15;

  return T;
}
